#include<iostream>

using namespace std;

int niz[100010];

int main()
{
	int h,n;
	scanf("%d%d",&h,&n);
	int matrica[h+10][n+10];
	for(int i=1;i<=h;i++)
	{
		for(int j=0;j<n;j++)
		{
			scanf("%d",&matrica[i][j]);
		}
	}
	for(int i=0;i<n;i++)
	{
		niz[i]=1;
	}
	for(int i=1;i<=h;i++)
	{
		int levikraj,desnikraj;
		int voda=0;
		bool kamen=false;
		for(int j=0;j<n;j++)
		{
			if(matrica[i][j]==0 && !kamen)
			{
				voda+=niz[j];
				levikraj=j-1;
				kamen=true;
				niz[j]=0;
			}
			else if(matrica[i][j]==0 && kamen)
			{
				voda+=niz[j];
				niz[j]=0;
			}
			else if(matrica[i][j]==1 && kamen)
			{
				desnikraj=j;
				if(levikraj==-1)
				{
					niz[desnikraj]+=voda;
				}
				else
				{
					niz[desnikraj]+=voda/2;
					niz[levikraj]+=voda/2;
					if(voda%2==1)
					{
						if(i%2==0)
							niz[desnikraj]++;
						else
							niz[levikraj]++;
					}
					
				}
				voda=0;
				kamen=false;
			}																	
		}
		if(kamen)
		{
			niz[levikraj]+=voda;
		}
	}
	for(int i=0;i<n;i++)
	{
		printf("%d ",niz[i]);
	}
		
	
}